// "Hello, World!" Demo
// Made possible by Alberto Covarrubias' Cursor Demo source code.
// (Not to mention his VB C compiler and Virtual Environment programs...)
// Copyright (c) Amos Bieler 2002 <abieler@gmx.net>

#include "vbaddr.h"	// It _was_ useful! Thanks, Alberto!  But, I think I made it more so...
//#include "vbtypes.h"	// This header is already included by vbhw.h
#include "vbhw.h"	// This header contains prototypes for the default library

// This static HWORD array is the "font," such as it is ;)
// As you can see, it is, appropriately, called chFont.
static HWORD chFont[] = {
	0x3C0F,0x3C0F,0x3C0F,0x3FFF,0x3C0F,0x3C0F,0x3C0F,0x0000, // H
	0x3FFF,0x000F,0x000F,0x00FF,0x000F,0x000F,0x3FFF,0x0000, // E
	0x000F,0x000F,0x000F,0x000F,0x000F,0x000F,0x3FFF,0x0000, // L
	0x0FFC,0x3C0F,0x3C0F,0x3C0F,0x3C0F,0x3C0F,0x0FFC,0x0000, // O
	0x0000,0x0000,0x0000,0x0000,0x0000,0x000F,0x000D,0x0003, // ,
	0x380B,0x380B,0x3C0F,0x2E2E,0x2EEE,0x0FFC,0x0F3C,0x0000, // W
	0x0FFF,0x3C0F,0x3C0F,0x3C0F,0x0FFF,0x0F0F,0x3C0F,0x0000, // R
	0x0FFF,0x3C0F,0x3C0F,0x3C0F,0x3C0F,0x3C0F,0x0FFF,0x0000, // D
	0x2800,0x3F00,0x2F80,0x0BC0,0x00F0,0x0020,0x000F,0x000F	 // !
};

// This one is the "BGMap" that spells out the message using chars from chFont.
static HWORD bgMessage[] = {0, 1, 2, 2, 3, 4, 5, 3, 6, 2, 7, 8};	/* HELLO,WORLD! */


// Set up the video hardware so the screen doesn't display the random, uninitialized VRAM.
void Init()
{
	VIP_REGS(BRTA)  = 0;	// Set the brightness registers to 0 (Black.)
	VIP_REGS(BRTB)  = 0;
	VIP_REGS(BRTC)  = 0;
	VIP_REGS(GPLT0) = 0xE4;	// Set all eight palettes to: 11, 10, 01, 00
	VIP_REGS(GPLT1) = 0xE4;	// (i.e. "Normal" dark to light progression.)
	VIP_REGS(GPLT2) = 0xE4;
	VIP_REGS(GPLT3) = 0xE4;
	VIP_REGS(JPLT0) = 0xE4;
	VIP_REGS(JPLT1) = 0xE4;
	VIP_REGS(JPLT2) = 0xE4;
	VIP_REGS(JPLT3) = 0xE4;
	VIP_REGS(BKCOL) = 0;	// Clear the screen to black before rendering
}

// The compiler only accepts a void main() without arguments.
void main()
{
	int p=8;	// The current parallax value (for animation.)

	vbReset();	// Reset the VB (not sure exactly what this entails,
			// but it sets up the column tables, at least.)

	Init();		// Our own initialization routine from above.

	// Copy the font chars into the char table and the string into the first BGMap.
	// This routine from the default library is very useful!

	// memcpy(destination address, source address, number of bytes)
	memcpy((void*)CharSeg0,(void*)chFont,9*16);
	memcpy((void*)BGMap(0),(void*)bgMessage,24);

	// Set up the first world (31) to hold our message and center it on the screen.
	// Set up the second world (30) to be the End world.  It and all others are not drawn.
	// (Using another handy routine from the default library...)

	// See vbaddr.h for the constants from which to build a world header (WRLD_*)
	// Just OR them together like I did with LON and RON below.

	// vbSetWorld (World, Header, GX, GP, GY, MX, MP, MY, Width, Height)
	vbSetWorld(31,(WRLD_LON|WRLD_RON),144,p,108,0,0,0,95,7);
	vbSetWorld(30,WRLD_END,0,0,0,0,0,0,0,0);

	// Yet another "black box" function to handle the screen for us.
	vbDisplayOn();

	// Here's one that fades in the BRT* registers from black for a nice effect.
	vbFXFadeIn();

	while(1)
	{

	// Everything inside this infinite while loop is the animation
	// and is pretty simple when you understand what is happening
	// in the rest of the program.

		for(p=8;p > 0;p--)
		{
			vbSetWorld(31,(WRLD_LON|WRLD_RON),144,p,108,0,0,0,95,7);
			// One more helper function.  This waits for the specified
			// number of frames before continuing.  Not useful for games
			// because there is stuff that needs to be done while the
			// human is looking at the current frame, but it's sufficient
			// for this simple demo ;)
			vbWaitFrame(15);
		}
		for(p=0;p < 8;p++)
		{
			vbSetWorld(31,(WRLD_LON|WRLD_RON),144,p,108,0,0,0,95,7);
			vbWaitFrame(15);
		}
	}
}
